Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.rules
Class AbleCorrelationRule

    java.lang.Object
      com.ibm.able.rules.AbleRule
          com.ibm.able.rules.AbleCorrelationRule

All Implemented Interfaces:
  java.io.Serializable

public class AbleCorrelationRule
extends AbleRule
implements java.io.Serializable

This class contains an event-condition-action rule used for event correlation and temporal rule processing.

See Also:
  Serialized Form

Field Summary
`protected java.util.HashSet` | `myBindings`
`protected java.util.Vector` | `myCloneableArgs`
`protected java.util.Vector` | `myConditionArgs`
`protected java.util.Vector` | `myConsequents`
`protected java.util.Vector` | `myEventSelectors`
`protected AbleLifespan` | `myLifeSpan`

Fields inherited from class com.ibm.able.rules.AbleRule
`myBooleanTruth, myBreakpoint, myComment, myEnabled, myFinalFlag, myFiredCount, myFiredFlag, myId, myLabel, myLocation, myPreConditions, myPriority, myPrompt, myProperties, myRdRefs, myRuleBlock, myRuleSet, myTemplateFlag, myTemplateName, myTemplateValues, myWrRefs, PriorityDefault, RuleIdInitial`

Constructor Summary
`AbleCorrelationRule(java.lang.String theLabel, AbleRd thePriority, java.util.Vector theConditionArgs, java.util.Vector theCloneableArgs, java.util.Vector theEventSelectors, java.util.Vector theActions, AbleRuleSet theRuleSet)` Create a new event-condition-action rule with the specified priority, arguments, event selectors, and actions.

Method Summary
`java.lang.String` | `arlString()` Return a formal Able Rule Language (ARL) String.
`java.lang.String` | `armlString()` Return a formal XML string.
`java.util.Vector` | `getActions()` Retrieve the rule's list of "do" action clauses.
`java.util.Vector` | `getCloneableArgs()` Retrieve the rule's cloneable arguments.
`java.util.Vector` | `getConditionArgs()` Retrieve the rule's condition arguments.
`java.util.Vector` | `getEventTypes()` Return the names of events processed by this rule
`int` | `getNumberOfSelectors()` Retrieve the number of selector clauses in this rule.
`java.util.Vector` | `getSelectors()` Retrieve the rule's list of selector clauses.
`java.lang.String` | `getTemplateString(java.util.Vector theTemplateVars)` Retrieve a text format string for use by rule templates.
`java.lang.String` | `toString()` Retrieve a string describing (the contents of) the object.
`java.lang.String` | `traceString(int theTraceStringFlavor)` Retrieve a string describing (the contents of) the object.
`java.lang.String` | `xmlString()` Return a formal XML string.

Methods inherited from class com.ibm.able.rules.AbleRule
`addHeaderRdReferences, addRdReference, addRdReferences, addWrReference, addWrReferences, arlActionBlockString, arlPreConditionsString, armlPreConditionsString, armlPriorityString, armlPropertiesString, checkTimePeriodPreConditions, clearBreakpoint, getArlComment, getBooleanTruth, getBreakpoint, getComment, getId, getIdLabelString, getLabel, getLocation, getMetaData, getPreConditions, getPriority, getPrompt, getPromptString, getProperties, getProperty, getRdReferences, getTemplateActionBlockString, getTemplateHeaderString, getTemplateName, getTemplateValues, getTemplateVars, getWrReferences, isDefaultPriority, isEnabled, isFinal, isFired, isGeneratedFromTemplate, isTemplate, logTrace, removeProperty, reset, setBooleanTruth, setBreakpoint, setComment, setEnabled, setFinal, setFired, setId, setLocation, setMetaData, setPreConditions, setPriority, setPrompt, setProperties, setProperty, setTemplate, setTemplateName, setTemplateValues, xmlPreConditionsString, xmlPriorityString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### myLifeSpan

    protected AbleLifespan myLifeSpan

### myConditionArgs

    protected java.util.Vector myConditionArgs

### myCloneableArgs

    protected java.util.Vector myCloneableArgs

### myConsequents

    protected java.util.Vector myConsequents

### myEventSelectors

    protected java.util.Vector myEventSelectors

### myBindings

    protected java.util.HashSet myBindings

Constructor Detail

### AbleCorrelationRule

    public AbleCorrelationRule(java.lang.String theLabel,
                               AbleRd thePriority,
                               java.util.Vector theConditionArgs,
                               java.util.Vector theCloneableArgs,
                               java.util.Vector theEventSelectors,
                               java.util.Vector theActions,
                               AbleRuleSet theRuleSet)

  Create a new event-condition-action rule with the specified priority, arguments, event selectors, and actions.

Parameters:
  `theLabel` - The unique label, or name, of this rule.

  `thePriority` - The priority of this rule.

  `theConditionArgs` - A list of AbleRd objects that define the condition arguments of this rule. The list is cloned.

  `theCloneableArgs` - A list of AbleRd objects that define the cloneable arguments of this rule. The list is cloned.

  `theEventSelectors` - A list of AbleSelector objects that define the event selectors (variables and constraints) of this rule. The list is cloned.

  `theActions` - A list of AbleConsequentClause objects that define the actions of this rule.

Method Detail

### getSelectors

    public final java.util.Vector getSelectors()

  Retrieve the rule's list of selector clauses.

  Returns:
    A reference to the actual list of selector clauses. This list may not be empty.

### getConditionArgs

    public final java.util.Vector getConditionArgs()

  Retrieve the rule's condition arguments.

  Returns:
    A reference to the list of condition arguments. This list may not be empty.

### getCloneableArgs

    public final java.util.Vector getCloneableArgs()

  Retrieve the rule's cloneable arguments.

  Returns:
    A reference to the list of cloneable arguments. This list may not be empty.

### getActions

    public final java.util.Vector getActions()

  Retrieve the rule's list of "do" action clauses.

  Returns:
    A reference to the actual list of do action clauses. This list may not be empty.

### getNumberOfSelectors

    public int getNumberOfSelectors()

  Retrieve the number of selector clauses in this rule.

  Returns:
    A reference to the actual list of selector clauses. This list may be empty (and will be empty if the rule is an assertion rather than a conditional rule), but the list is never null.

### getEventTypes

    public java.util.Vector getEventTypes()

  Return the names of events processed by this rule

### arlString

    public java.lang.String arlString()

  Return a formal Able Rule Language (ARL) String.

  Specified by:
    `arlString` in class `AbleRule`
  Returns:
    A String describing the object in Able rule language.

### xmlString

    public java.lang.String xmlString()

  Return a formal XML string.

  Specified by:
    `xmlString` in class `AbleRule`
  Returns:
    A String describing the object in XML.

### armlString

    public java.lang.String armlString()

  Description copied from class: `AbleRule`
  Return a formal XML string.

  Specified by:
    `armlString` in class `AbleRule`
  Returns:
    A String describing the object in XML.

### getTemplateString

    public java.lang.String getTemplateString(java.util.Vector theTemplateVars)
                                       throws AbleDataException

  Retrieve a text format string for use by rule templates. The string contains "{n}" strings, where the index 'n' corresponds to the template variables defined in the rule template. This string is based on the standard arlString() representation of the rule. After replacement of the template variable values, the resulting string must be a valid ARL format string that can be parsed.

  Specified by:
    `getTemplateString` in class `AbleRule`
  Parameters:
    `theTemplateVars` - An ordered list of template variables referenced by this rule.
  Returns:
    A Text format string used to create a new rule instance.
  Throws:
    `AbleDataException`
  See Also:
    `AbleRuleTemplate`

### toString

    public java.lang.String toString()

  Retrieve a string describing (the contents of) the object.

  Overrides:
    `toString` in class `AbleRule`
  Returns:
    A String containing the current contents of the object.

### traceString

    public java.lang.String traceString(int theTraceStringFlavor)

  Retrieve a string describing (the contents of) the object.

  Specified by:
    `traceString` in class `AbleRule`
  Parameters:
    `theTraceStringFlavor` - An Able.TraceStringFlavor value.

  Returns:
    A String containing the current contents of the object.

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005